﻿#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
; #Warn  ; Enable warnings to assist with detecting common errors.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.

#IfWinActive, ahk_exe sublime_text.exe

^!r:: ; Ctrl+Alt+R : 	Salva script AHK e recarrega
	SetTitleMatchMode, 2
	if WinActive("StudioFullScreen.ahk")
	{
		Send ^s
		WinGetActiveTitle, wtitle
		if wtitle contains %A_ScriptFullPath%
			Reload
	}
	return

ErroAbort(msg) {
	MsgBox, %msg%
	Exit ; abort
}


MClick(x, y, Tempo:=false) {
	MouseMove, x, y
	Sleep 50
	Click
	if Tempo 
		Sleep Tempo
}

#IfWinActive, ahk_exe RobloxStudioBeta.exe

	^F11:: ; Ctrl+F11
		Path := ""

	 	; avoid mouse over any icon
			MouseMove, 0, 0
			Sleep 50

		; read current status from file
			IniRead, FullScreen, %Path%Status.ini, Status, FullScreen
			if (FullScreen = "ERROR")
				FullScreen := 0

		; open Tool Bar (if closed)
			ImageSearch, xClose, yClose, 0, 0, A_ScreenWidth, 80, %Path%bar_close.png
			BarIsOpen := not ErrorLevel
			if not BarIsOpen ; bar is closed, must open it before
			{
				ImageSearch, x, y, 0, 0, A_ScreenWidth, 80, %Path%bar_open.png
				if ErrorLevel
					ErroAbort("Couldn't find bar open/close icons in Studio")
				MClick(x+3, y+3, 100)
			}

		; click on "View" button
			ImageSearch, x, y, 0, 0, A_ScreenWidth, 80, %Path%view_off.png
			if ErrorLevel
				ImageSearch, x, y, 0, 0, A_ScreenWidth, 80, %Path%view2.png
			if not ErrorLevel
				MClick(x+10, y+10, 100)
			ImageSearch, x, y, 0, 0, A_ScreenWidth, 80, %Path%view_on.png
			if ErrorLevel
				ErroAbort("Couldn't find View tab in Studio")

		; save the status of all current open windows 
			if not FullScreen
			{
				IniWrite, 0, %Path%Status.ini, Status, FullScreen ; FullScreen off

				Loop,  19
				{
					Image = %A_Index%_on.png
					ImageSearch, x, y, 0, 0, A_ScreenWidth, 150, %Path%%Image%
					ButtonOn := not ErrorLevel
					if ButtonOn
					{
						x := x + 5
						y := y + 5
						Value = %x%,%y%
						IniWrite, %Value%, %Path%Status.ini, Buttons, Button%A_Index%
						MClick(x, y, 50) ; click on the button to disable it (close the window)
					}
					Else
						IniDelete, %Path%Status.ini, Buttons, Button%A_Index%

				}
				Send ^{F1} ; close Too Bar
				IniWrite, 1, %Path%Status.ini, Status, FullScreen ; FullScreen on
			}
			Else ; read the all original windows previously opened to save/restore
			{
				Loop,  19
				{
					IniRead, Value, %Path%Status.ini, Buttons, Button%A_Index%
					if not (Value = "ERROR")
					{
						Array := StrSplit(Value, ",")
						x := Array[1]
						y := Array[2]
						MClick(x, y, 50)
					}
					IniWrite, 0, %Path%Status.ini, Status, FullScreen ; FullScreen off
				}
			}
	Return